Minion = Object.extend(Object)

function Minion.new(self, x, y, radius, healthMax, dmg, range)
  self.minionType = minionType

  self.x = x
  self.y = y 
  self.radius = radius
  self.color = {12,23,147} --extra_color.royal  
  
  self.healthMax =  healthMax
  self.currentHealth = healthMax
  self.dmg = dmg
  self.actualSpeed = 200 -- make changes to max here
  self.speed = self.actualSpeed
  
  self.range = range
  self.attackSpeed = 0.87
  
  melee_dmg_calc = cron.every(self.attackSpeed, function() user.currentHealth = user.currentHealth - dmg  end)
  timer = 0
end



function Minion:update(dt)

  minion2user = angle2points(user.y, self.y, user.x, self.x)
  --melee minions
  if self.radius >= self.range then
    
    --if minion in contact with user, stop moving and do damage
    if distance(self.y, user.y, self.x, user.x) < user.radius + self.range then
      self.speed = 0
      dmg = self.dmg
      melee_dmg_calc:update(dt)
    
     --if range is less than distance to user then, move minion to the user 
    --reset the autoattack timer
    elseif distance(self.y, user.y, self.x, user.x) > user.radius + self.range then
      self.speed = self.actualSpeed
      timer = 0
      if self.x ~= user.x and self.y ~= user.y then
        self.x = self.x + (math.cos(minion2user) * self.speed * dt) 
        self.y = self.y + (math.sin(minion2user) * self.speed * dt)
    
        self.x = math.floor(self.x)
        self.y = math.floor(self.y)
    
      end
    
    end
    
  
   --ranged minion
  elseif self.radius < self.range then
    
    --if in agro range. stop moving and start autoattacking
    if distance(self.y, user.y, self.x, user.x) < self.range - user.radius then
      
      self.speed = 0
      
        
      --sets the timer to shoot every time it counts up to == the attackspeed
      timer = timer + dt 
      if timer > self.attackSpeed then
        table.insert(listOfCasts, CreepCast(self.x, self.y, self.dmg )) -- x, y, dmg
        timer = 0
      end
    
    
    --if range is less than distance to user then, move minion to the user 
    --reset the autoattack timer
    elseif distance(self.y, user.y, self.x, user.x) > self.range - user.radius then
      self.speed = self.actualSpeed
      timer = 0
      
      if self.x ~= user.x and self.y ~= user.y then
        self.x = self.x + (math.cos(minion2user) * self.speed * dt) 
        self.y = self.y + (math.sin(minion2user) * self.speed * dt)
    
        self.x = math.floor(self.x)
        self.y = math.floor(self.y)
    
      end
    end
  end
end

function Minion:draw()
  love.graphics.setColor(love.math.colorFromBytes(self.color))
  love.graphics.circle("fill", self.x, self.y, self.radius)
  
  love.graphics.setColor(love.math.colorFromBytes(extra_color.bloodOrange))
  love.graphics.print( timer, 20, 20)
  
  love.graphics.setColor(love.math.colorFromBytes(extra_color.bubbleGumPink))
  love.graphics.circle("line", self.x, self.y, self.range)
  
end




CreepCast = Object.extend(Object)

function CreepCast:new(x,y,dmg)
  self.x = x
  self.y = y
  self.radius = 3
  self.color = {0,255,0}
  
  self.dmg = dmg
  self.speed = 100
  
end

function CreepCast:update(dt, cast2user)
  
  --shoots bullet at the user
  cast2user = math.atan2(user.y - self.y , user.x - self.x)
  self.x = self.x + math.cos(cast2user) * self.speed * dt
  self.y = self.y + math.sin(cast2user) * self.speed * dt
  
  --if bullet hits the player reduce the damage by value then set to 0. will then be removed elsewhere in main (make init)
  if distance(self.y, user.y, self.x, user.x) < self.radius + user.radius then
    user.currentHealth = user.currentHealth - self.dmg
    self.dmg = 0
  end
  
  --if bullet is x distance from user, increase the speed (sheepolution somewhere)
  
  --if distance(self.y, user.y, self.x, user.x) >  then
   -- self.speed = self.speed * 3
  --else
   -- self.speed = 200
  --end

end

function CreepCast:draw()
  love.graphics.setColor(love.math.colorFromBytes(self.color))
  love.graphics.circle("fill", self.x, self.y, self.radius)
end